#!/usr/bin/perl -w -I/usr/sausalito/perl -I.

use CCE;
use Sauce::Config;
use Sauce::Util;

# apparenlty the ethernet drivers are modules now, so we need
# to run ifconfig to get the modules loaded before getting the MACs
system("/sbin/ifconfig -a >/dev/null 2>&1");

my $cce = new CCE;
$cce->connectfd(\*STDIN,\*STDOUT);

my $oid = $cce->event_oid();
my $obj = $cce->event_object();
my $device = $obj->{'device'} || 'eth1';

my @data = `/sbin/ifconfig $device`;
if ($data[0] =~ m/HWaddr (\S\S:\S\S:\S\S:\S\S:\S\S:\S\S)/) {
	my $mac = $1;
  print STDERR "mac address for device $device: $mac\n";
  $cce->set($oid, "", { 'device' => $device, 'mac' => $mac });
}

$cce->bye('SUCCESS');
exit(0);
