#!/usr/bin/perl -w

use lib qw( /usr/sausalito/perl );
use CCE;
use Sauce::Util;
use FileHandle;

my $cce = new CCE;
$cce->connectfd();

my $oid = $cce->event_oid();
my $obj = $cce->event_object();
my $new = $cce->event_new();
my $old = $cce->event_old();

if ($new->{name} || $new->{members}) {
  if (! -d "/etc/group.d" ) { 
	mkdir ("/etc/group.d", 0755);
  }
  chmod(0755, "/etc/group.d");
  my $fn = "/etc/group.d/" . $obj->{name};
  my $fh = new FileHandle(">$fn");
  if ($fh) {
	my @members = $cce->scalar_to_array($obj->{members});
	print $fh join("\n",@members),"\n";
	$fh->close();
	chmod(0755, $fn);
  } else {
    	print STDERR "Could not open $fn: $!\n";
  }
}

if (
  $cce->event_is_destroy() || 
  ($old->{name} && $new->{name} && ($new->{name} ne $old->{name})) 
) {
	unlink ("/etc/group.d/".$old->{name});
}

if ($new->{name} || $new->{members}) {
  my @members = $cce->scalar_to_array($obj->{members});

  if ($#members < 0) { push (@members, 'nobody'); }
  
  Sauce::Util::editfile('/etc/mail/aliases',
	\&Sauce::Util::replace_unique_entries,
	$oid, { 
		$obj->{name} . "_alias" => join(",",@members)
	});
}

if (
	($cce->event_is_destroy) ||
  	($old->{name} && $new->{name} && ($new->{name} ne $old->{name})) 
   )
{
  Sauce::Util::editfile('/etc/mail/aliases',
	\&Sauce::Util::replace_unique_entries,
	$oid, {} );
}

system("/usr/bin/newaliases &> /dev/null");
if ($?>>8 != 0) {
      print STDERR "newaliases failed ... I don't know what to do.\n";
      # FIXME: handle failure
}

$cce->bye("SUCCESS");
exit(0);
  
