#!/usr/bin/perl
# $Id: handle_password.pl,v 1.1 2000/07/18 00:28:32 jmayer Exp $

use strict;
use lib qw( /usr/sausalito/perl );
use CCE;
use Sauce::Util;

my $cce = new CCE; $cce->connectfd();
my $obj = $cce->event_object();

my $name = $obj->{name};
my $md5_pw = $obj->{md5_password};

my $today = int(time() / 60 / 24);

# precompile regexes:
my ($re1, $re2);
$re1 = qr/^${name}:[^:]*:\d*:/;
if ($name eq 'admin') {
  $re2 = qr/^root:[^:]*:\d*:/;
} else {
  $re2 = qr/^dont-match-anything$/;
}

my $done = 0;

my $fn = sub {
  my ($fin, $fout) = (shift, shift);
  while (defined($_ = <$fin>)) {
    if (s/$re1/${name}:${md5_pw}:${today}:/) { $done = 1; }
    s/$re2/root:${md5_pw}:${today}:/;
    print $fout $_;
  }
};

Sauce::Util::editfile('/etc/shadow', $fn);

if ($done) {
  $cce->bye("SUCCESS");
  exit(0);
} else {
  print STDERR "Could not change ${name}'s password.\n";
  $cce->bye("FAIL");
  exit(1);
}

