#!/usr/bin/perl -w -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/sauce-basic

my $DEBUG = 0;

use CCE;
use Sauce::Util;
#use Workgroup;

my $cce = new CCE;
$cce->connectfd(\*STDIN,\*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();
my $new = $cce->event_new();
my $oid = $cce->event_oid();

$DEBUG && print STDERR "$0: modifying group ",$obj->{name},"\n";

my $members = $obj->{members} || "";
my @members = CCE->scalar_to_array($members);
$members = join(",",@members);

# Workgroup::validate($cce);

my $fun = sub {
	my ($fin, $fout) = (shift, shift);
	my $oldname = $old->{name};
	my $newname = $obj->{name};
	my $ok = 0;
	while ($_ = <$fin>) {
		if (m/^${oldname}:x:(\d+)/) {
			print $fout $newname,":x:",$1,":",$members,"\n";
			$ok = 1;
		} else {
			print $fout $_;
		}
	}
	return $ok;
};
my $ret = Sauce::Util::editfile("/etc/group", $fun);
chmod(0644,'/etc/group');
if (!$ret) {
	print STDERR "Could not edit /etc/group\n";
	$cce->bye('FAIL');
	exit 1;
};

if ($old->{name} ne $obj->{name}) {
	# move the group home directory
	my $olddir = "/home/groups/".$old->{name};
	my $newdir = "/home/groups/".$obj->{name};
	system ("/bin/mv", $olddir, $newdir);
};

$cce->bye('SUCCESS');
exit 0;

# done.
