#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
#$Id: modsystem.pl,v 1.4 2000/09/15 09:15:04 jmayer Exp $

use strict;
use Sauce::Config;
use Sauce::Util;
use CCE;
# use System;

my $cce = new CCE;
$cce->connectfd(\*STDIN,\*STDOUT);

# retreive user object data:
my $oid = $cce->event_oid();

if (!$oid) {
	# something is very, very wrong.
  $cce->bye('FAIL', 'Bad CSCP header');
  exit(1);
}

my $obj = $cce->event_object();
my $new = $cce->event_new();
my $old = $cce->event_old();
use Data::Dumper;

##########################################################################
# error checking
##########################################################################
# System::validate();

##########################################################################
# actuate changes
##########################################################################

my $name = $obj->{hostname};
if ($obj->{domainname} && $obj->{hostname} !~ m/\.$obj->{domainname}$/) {
  $name = join(".",($obj->{hostname},$obj->{domainname}));
}
$name =~ s/\.+/\./g;
if (length($name) > 40) {
  $cce->baddata(0, 'hostname', 'hostname-too-long');
  $cce->bye('FAIL');
  exit 1;
}
if ($name =~ m/^localhost\./) {
      $name = "localhost";
}

if (defined($new->{hostname}) || defined($new->{domainname}))
{

  # update /etc/HOSTNAME
  {
      my $fn = sub {
      my ($fin, $fout) = (shift, shift);
      my $name = shift;
      print $fout $name,"\n";
      return 1;
    };
    Sauce::Util::editfile('/etc/HOSTNAME', $fn, $name)
  }
  
  # run the hostname command 
  system('/bin/hostname', $name);
}

if (defined($new->{hostname}) 
  || defined($new->{domainname})
  || defined($new->{gateway}) )
{
  # update /etc/sysconfig/network
  {
    my $fn = sub {
      my ($fin, $fout) = (shift,shift);
      my ($name, $gateway) = (shift, shift);
      my %hash = ();
      while ($_ = <$fin>) {
      	chomp($_);
      	if (m/^\s*([A-Za-z0-9_]+)\s*\=\s*(.*)/) { $hash{$1} = $2; }
      }
      $hash{HOSTNAME} = $name;
      $hash{NETWORKING} = "yes";
      $hash{FORWARD_IPV4} = $hash{FORWARD_IPV4} || "false";
      $hash{GATEWAY} = $gateway || $hash{GATEWAY} || "";
      if (defined($gateway)) { $hash{GATEWAY} = $gateway; };
      foreach $_ ( sort keys %hash ) {
      	print $fout $_,"=",$hash{$_},"\n";
      }
      return 1;
    };
    Sauce::Util::editfile("/etc/sysconfig/network", $fn, $name, $obj->{gateway});
    chmod(0644,'/etc/sysconfig/network');
  };
}

# comfortable shoes.
$cce->bye('SUCCESS');
exit(0);
