#!/usr/bin/perl

use lib qw( /usr/sausalito/perl );
use CCE;

my %reserved = map { $_ => 1 } qw(
root bin daemon sys adm tty disk lp mem kmem wheel httpd mail news uucp man
floppy admin guest nobody users console postgres slocate 
majordomo anonymous 
);

my $cce = new CCE;
$cce->connectfd(\*STDIN,\*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();
my $new = $cce->event_new();
my $oid = $cce->event_oid();

# check for duplicates
if ($new->{name}) {
  my (@dups) = $cce->find("Workgroup", { 'name' => $obj->{'name'} });
  push (@dups, $cce->find("User", { 'name' => $obj->{'name'} }));
  push (@dups, grep {m/^\s*$obj->{name}:\s+/} `cat /etc/mail/aliases`);
  if ($reserved{$obj->{'name'}}) { push (@dups, "reserved"); }
  if ($#dups > 0) {
    $cce->baddata($oid, 'name', '[[base-workgroup.groupNameAlreadyTaken]]');
    $cce->bye('FAIL');
    exit(1);
  }
}

$cce->bye('SUCCESS');
